# v0.3.0 Release Notes

Main focus for this release was working on code quality and API stabilization. The two
main tickets to complete for this release were:

* [#8](https://gitlab.com/Chips4Makers/PDKMaster/-/issues/8): 100% code coverage with unittests
* [#9](https://gitlab.com/Chips4Makers/PDKMaster/-/issues/9): Extended API reference: doc strings for each non-trivial class, method and function.

The
[reference documentation](https://chips4makers.io/documentation/PDKMaster/v0.3.0/) has also been released on the [chips4makers.io website](https://chips4makers.io/blog).

During the development of the unit tests also several bugs were fixed or incomplete
implementation of features. This shows the usefulness of having the unit tests. Already part
of the API stabilization planned for
[v0.9.0](https://gitlab.com/Chips4Makers/PDKMaster/-/milestones/3) has been completed along
the way.

Also code improvements have been done for supporting the bandgap and ADC circuit and layout
generation for Sky130.

That said both the unit tests as well as the documentation are a first version with lot's
of room for improvement. In several places the unit tests just run code to reach full coverage
without actual testing the correctness. For the API docs focus has been on the user facing
part of the API and the internal API documentation is still lacking in lot's of places.
In good open source fashion external contributions for improving the first version are
welcome.
